#property copyright "Copyright  2008, Evgeniy Trofimov"
#property link      ""
#define Slippage 3
#define mn 20081229
//---- input parameters
extern double  FIXLOT      = 0.10; // 0,   
extern double  MAXIMUMRISK = 0.10;
extern int     MyPeriod    =   12;
extern double  AngleLimit  =  4.5;
int     BeginHour   =   10;
int     EndHour     =   21;
//----
static double stoplimit, spread, MINLOTS, MAXLOTS, LOTVAL, round;
//+------------------------------------------------------------------+
int init() {
   stoplimit = (MarketInfo(Symbol(), MODE_STOPLEVEL)+Slippage)*Point;
   spread  = MarketInfo(Symbol(), MODE_SPREAD)*Point;
   MINLOTS = MarketInfo(Symbol(), MODE_MINLOT);
   MAXLOTS = AccountFreeMargin()*0.5/MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   if(MAXLOTS>MarketInfo(Symbol(), MODE_MAXLOT)) MAXLOTS = MarketInfo(Symbol(), MODE_MAXLOT);
   LOTVAL  = MarketInfo(Symbol(), MODE_TICKVALUE);
   round   = MathAbs(MathLog(MarketInfo(Symbol(), MODE_LOTSTEP))/MathLog(10.0))+0.5; //  
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   static datetime LastTime;
   double LowDeflection,HighDeflection;
   if(LastTime==Time[0]) return(0);
   LastTime=Time[0];
   if(Block()) {
      LastTime=Time[1];
      return(0);
   }
   int ticket=OpenTicket();
//   ,   StopLoss:
   if(ticket>0) {
      OrderSelect(ticket, SELECT_BY_TICKET);
      if(OrderType()==OP_BUY) {
         LowDeflection= iCustom(NULL,0,"MLSOnGraphics",MyPeriod,0,0,true, 3,1);
         Modify(ticket, LowDeflection, 0);
      } else if(OrderType()==OP_SELL) {
         HighDeflection=iCustom(NULL,0,"MLSOnGraphics",MyPeriod,0,0,true, 2,1);
         Modify(ticket, HighDeflection, 0);
      }
   } else { //   
      if(TimeHour(LastTime)>=BeginHour && TimeHour(LastTime)<EndHour) {
         if((Angle(2),Angle(1),Angle(0))) {
            if(Angle(1)>Angle(0) && Angle(0)<-AngleLimit) {
               HighDeflection=iCustom(NULL,0,"MLSOnGraphics",MyPeriod,0,0,true, 2,1);
               SELL(GetLots((HighDeflection-Bid)/Point), HighDeflection, Bid-(HighDeflection-Ask)/2);
            } else if(Angle(1)<Angle(0) && Angle(0)>AngleLimit) {
               LowDeflection= iCustom(NULL,0,"MLSOnGraphics",MyPeriod,0,0,true, 3,1);
               BUY(GetLots((Ask-LowDeflection)/Point), LowDeflection, Ask+(Bid-LowDeflection)/2);
            }
         }
      }//  
   }
   return(0);
}
//+------------------------------------------------------------------+
double Angle(int index) {
   return(iCustom(NULL,0,"MLS-HL4-Angle",MyPeriod,0,index+1));
}
//+------------------------------------------------------------------+
bool (double Point1, double Point2, double Point3) {
// True,  ,     
   double i;
   i=(1,3,Point1,Point3,2);
   if(MathAbs(Point2)<MathAbs(i)) return(true);
   return(false);
}
//+------------------------------------------------------------------+
double (double a,double b,double c,double d,double X) {
//A; X; B -   , C; D; -    .
    if(b - a == 0)
        return(100000000); //
    else
        return(d - (b - X) * (d - c) / (b - a));
}//End Function
//+------------------------------------------------------------------+
int OpenTicket(){
   //    
   //    
   int total = OrdersTotal();
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == mn)
         return(OrderTicket());
   }
   return(0);
}
//+------------------------------------------------------------------+
bool Block() {
   if(!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected()) {
      Print(" ,  ,     ");
      return(true);
   }
   return(false);
}
//+------------------------------------------------------------------+
int BUY(double lt, double sl, double tp) {
   int ticket = -1; //   Ask
   int LE=135;
   if(sl>0) {
      sl=NormalizeDouble(sl,Digits);
      if(Bid-sl<stoplimit) sl=Bid-stoplimit;
   }
   if(tp>0) {
      tp=NormalizeDouble(tp,Digits);
      if(tp-Ask<stoplimit) tp=Ask+stoplimit;
   }
   while(LE>134 && LE<139) {
      ticket = OrderSend(Symbol(), OP_BUY, lt, Ask, Slippage, sl, tp, WindowExpertName(), mn, 0, Blue); 
      LE = GetLastError();
      Sleep(20000);
      RefreshRates();
   }
   if (ticket > 0) Sleep(10000);
   return(ticket);
}
//+------------------------------------------------------------------+
int SELL(double lt, double sl, double tp) {
   int ticket = -1; //   Bid
   int LE=135;
   if(sl>0) {
      sl=NormalizeDouble(sl,Digits);
      if(sl-Ask<stoplimit) sl=Ask+stoplimit;
   }
   if(tp>0) {
      tp=NormalizeDouble(tp,Digits);
      if(Bid-tp<stoplimit) tp=Bid-stoplimit;
   }
   while(LE>134 && LE<139) {
      ticket = OrderSend(Symbol(), OP_SELL, lt, Bid, Slippage, sl, tp, WindowExpertName(), mn, 0, Red); 
      LE = GetLastError();
      Sleep(20000);
      RefreshRates();
   }
   if (ticket > 0) Sleep(10000);
   return(ticket);
}
//+------------------------------------------------------------------+
int Modify(int ticket, double sl, double tp) {
   if(OrderSelect(ticket, SELECT_BY_TICKET)) {
      sl=NormalizeDouble(sl,Digits);
      tp=NormalizeDouble(tp,Digits);
      if(OrderStopLoss()<sl+Slippage*Point/2 && OrderStopLoss()>sl-Slippage*Point/2
      && OrderTakeProfit()<tp+Slippage*Point/2 && OrderTakeProfit()>tp-Slippage*Point/2) return(0);
      if(OrderType()==OP_BUY) {
         if(sl>0) {
            if(OrderStopLoss()>0)
               if(OrderStopLoss()+Slippage*Point>=sl) return(0);
            if(Bid-sl<stoplimit) return(0);
         }
         if(tp>0) if(tp-Ask<stoplimit) return(0);
      } else if(OrderType()==OP_SELL) {
         if(sl>0) {
            if(OrderStopLoss()>0)
               if(OrderStopLoss()-Slippage*Point<=sl) return(0);
            if(sl-Ask<stoplimit) return(0);
         }
         if(tp>0) if(Bid-tp<stoplimit) return(0);
      }
      if(sl>0 && tp>0) {
         if(OrderModify(ticket,OrderOpenPrice(), sl, tp, 0)) Sleep(10000);
      } else if(sl>0) {
         if(OrderModify(ticket,OrderOpenPrice(), sl, OrderTakeProfit(), 0)) Sleep(10000);
      } else if(tp>0) {
         if(OrderModify(ticket,OrderOpenPrice(), OrderStopLoss(), tp, 0)) Sleep(10000);
      }
   }
   return(0);
}
//+------------------------------------------------------------------+
double GetLots(double STOPLOSS)
{
   double lot, result;
   if(FIXLOT == 0)
      lot = NormalizeDouble(AccountFreeMargin() * MAXIMUMRISK / (STOPLOSS * LOTVAL), round);
   else {
      lot = FIXLOT;
      return(lot);
   }

   if(lot < MINLOTS)
      lot = MINLOTS;
   else if(lot > MAXLOTS)
      lot = MAXLOTS;
      
   return(lot);
}
//+------------------------------------------------------------------+

